import nealParams as nealParameters
if (nealParameters.simulator=="spinnaker"):
    import pyNN.spiNNaker as sim
elif (nealParameters.simulator=="nest"):
    import pyNN.nest as sim
    import cPickle as pickle


#Functions to isolate differences between different list synapse constructors
class NealCoverFunctions:
    projections = []
    
    def __init__(self, simName):
        """
        self.DELAY = 1.0
        self.simulator = simName
        if self.simulator == "nest":
            exec("from nest import *")
        elif self.simulator == 'spinnaker':
            exec("from pyNN.spiNNaker import *")

        else: print "bad simulator in nealFunctions"
        """

    def nealProjection(self,preNeurons,postNeurons, connectorList,inhExc):
        newProjection = [preNeurons,postNeurons,inhExc,connectorList]
        self.projections.append(newProjection)

    def sameProjectionType(self,projectionA,projectionB):
        if ((projectionA[0] == projectionB[0]) and # pre Neurons 
            (projectionA[1] == projectionB[1]) and # post Neurons
            (projectionA[2] == projectionB[2])):    # inh or exc
            return True
        return False

    #collect the projections into projections that are pre post and type
    #specific.  Write those out in one fromList
    def nealApplyProjections(self):
        while (len(self.projections) > 0):
            projectionNumber = 0
            #get the first projection and collect all projections like it
            firstProjection = self.projections[0]
            connList = firstProjection[3]
            self.projections.remove(firstProjection)
            while (projectionNumber < len(self.projections)):
                if (self.sameProjectionType(self.projections[projectionNumber],
                           firstProjection)):
                    connList = connList + self.projections[projectionNumber][3]
                    #print projectionNumber,len(connList)
                    self.projections.remove(self.projections[projectionNumber])
                else:
                    projectionNumber = projectionNumber + 1
                    
            #actually put out the projections
            fromListConnector = sim.FromListConnector(connList)
            preNeurons = firstProjection[0]
            postNeurons = firstProjection[1]
            inhExc = firstProjection[2]
            if (nealParameters.simulator=="spinnaker"):
                if (nealParameters.spinnVersion == 3.0):
                    sim.Projection(preNeurons, postNeurons, fromListConnector,
                                   target=inhExc)
                elif (nealParameters.spinnVersion == 4.0):
                    sim.Projection(preNeurons, postNeurons, fromListConnector,
                                   receptor_type=inhExc)
            
            elif (nealParameters.simulator=="nest"):
                sim.Projection(preNeurons, postNeurons, fromListConnector) 

            else: print "bad simulator nealProjection"

        
